using System;
using System.Data.SqlTypes;
using System.IO;
using Bibliotecas.Model;


public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void stpCompacta_Arquivo(string caminho, string filtro, string arquivoCompactado, int nivelCompactacao, string senha)
    {

        string[] _arquivos;

        #region tratamento de entradas

        if (nivelCompactacao < 0 || nivelCompactacao > 9)
        {
            Retorno.Erro("Parametro invlido na variavel nivelCompactacao, use de 0 a 9 para compactar, sendo 9 o nivel mais alto (5 recomendado).");
            return;
        }
        try
        {
            if (!Directory.Exists(caminho))
            {
                Retorno.Erro("Caminho especificado no existe ou inacessivel.");
                return;
            }
        }
        catch
        {
            Retorno.Erro("Erro ao converter caminho especificado.");
            return;
        }

        try
        {
            _arquivos = Directory.GetFiles(caminho, filtro, SearchOption.TopDirectoryOnly);
        }
        catch
        {
            Retorno.Erro("Erro ao listar arquivos no caminho especificado.");
            return;
        }



        FileInfo ArquivoCompactado = new FileInfo(arquivoCompactado);

        if (!Directory.Exists(ArquivoCompactado.Directory.ToString()))
        {
            Retorno.Erro("Caminho do Arquivo compactado especificado no existe ou inacessivel.");
            return;
        }


        if (!(ArquivoCompactado.Extension.Trim() == ""))
        {
            try
            {
                ArquivoCompactado.Delete();
            }
            catch
            {
                Retorno.Erro("o Arquivo compactado especificado esta sendo usado.");
                return;
            }
        }
        else
        {
            Retorno.Erro("o Arquivo compactado especificado no possui exteno vlida.");
            return;
        }


        
        #endregion

        try
        {
            var compactador = new Compactador(Compactador.tipoCompactador.Compactar)
            {
                NivelCompactacao = nivelCompactacao
            };

            compactador.CriarArquivoCompactado(arquivoCompactado, senha);
            var quantidadeArquivos = compactador.insereArquivos(_arquivos);

            Retorno.Mensagem("Total de: (" + quantidadeArquivos + ") arquivos foram compactados em: " + arquivoCompactado);
        }
        catch (Exception e)
        {
            Retorno.Erro("Erro : " + e.Message);
        }
    }

};
