using System;
using System.IO;
using Bibliotecas.Model;


public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void stpDescompacta_Arquivo(string arquivoCompactado, string pastaDestino, string filtro, string senha)
    {

        #region tratamento de entradas


        var ArquivoCompactado = new FileInfo(arquivoCompactado);
        if (!Directory.Exists(ArquivoCompactado.Directory.ToString()))
        {
            Retorno.Erro("Caminho do Arquivo compactado especificado no existe ou inacessivel.");
            return;
        }

        if (!ArquivoCompactado.Exists)
        {
            Retorno.Erro("O Arquivo Compactado no existe.");
            return;
        }

        #endregion

        try
        {
            var compactador = new Compactador(Compactador.tipoCompactador.Descompactar);
            compactador.DescompactaArquivo(arquivoCompactado, pastaDestino, filtro, senha);

            Retorno.Mensagem("Os arquivos foram descompactados em: " + pastaDestino);
        }
        catch (Exception e)
        {
            Retorno.Erro("Erro : " + e.Message);
        }
    }
};
